#include <plib.h>
#include <p_serial.h>
#include <p_keyb.h>


#define TMEXUTIL
#include "Tmexutil.H" 
#include "tmexinc.h"
#define CBR_19200 19200
#define CBR_9600 9600

//necessary to see output on workabout
#define SCREENWIDTH 40
#define SCREENHEIGHT 9
unsigned char state_buf[5125];
GLDEF_D P_RECT _DefScreenRect = {0,0,SCREENWIDTH,SCREENHEIGHT};


GLDEF_C main()
{
   char buf[200];
   short flag,i,didsetup=0;
   short ROM[9];
   short PortNum=0,PortType=5;
   long SHandle;
   char key = 'y';
   short count=0,m,hn;     
   ULONG timelap;
   unsigned char flname[] = { 'L','O','G',' ',0,0 },data[1200]; 
   


   // get the TMEX driver version
   p_printf("PSION DEMO Version 1.00");
   p_printf("Dallas Semiconductor Corporation");
   p_printf("Copyright (C) 1992-1999");
   p_printf("-- More --");
   p_getch();
   
   p_printf("Port number: %d     Port type: %d",PortNum,PortType);
   
   Get_Version(&buf[0]);
   p_printf("Main Driver:");
   p_printf("%s",buf);
   p_printf("TYPE%d:",PortType);
   p_printf("-- More --");
   p_getch();
  
   // loop to display the rom numbers until 'n'
   do
   {
     
      // get a session handle to the requested port
      SHandle = TMExtendedStartSession(PortNum,PortType,NULL);
      
      if (SHandle > 0)
      {
         // check to see if TMSetup has been done once
         if (!didsetup)
         {
            flag = TMSetup(SHandle);
            
            if (flag == 1 || flag == 2)
            {
               p_printf("TMSetup complete %d",flag);
               p_printf("-- More --");
               p_getch();

               didsetup = 1;
            }
            else
            {
               p_printf("ERROR doing setup %d",flag);
               p_printf("-- More --");
               p_getch();

               break;
            }
         }
         // only get the next rom after setup complete
         else
         {
            flag = TMNext(SHandle,&state_buf[0]);
            if (flag > 0)
            {
               count++;
               ROM[0] = 0;
               flag = TMRom(SHandle,&state_buf[0],&ROM[0]);
               
               for (i = 7; i >= 0; i--)
                  p_print("%02x ",ROM[i]);
               p_printf("");
                  
               if (ROM[0] == 0x0C)
               {
                  p_printf("overdrive %d ", TMAutoOverDrive(SHandle,state_buf,1));
                  p_printf("Format %d",TMFormat(SHandle,&state_buf[0]));
                  hn = TMCreateFile(SHandle,&state_buf[0],&m,flname);
                  p_printf("Create file %d  max %d",hn,m);      
                  
                  for (i = 0; i < 430; i++)
                     data[i] = (uchar)i;
                  
                  hn = TMWriteFile(SHandle,state_buf,hn,data,420);
                  p_printf("Write File %d",hn);  
                  p_printf("Close %d",TMCloseFile(SHandle,state_buf,hn)); 
                  
                  hn = TMOpenFile(SHandle,state_buf,flname);
                  p_printf("open file %d",hn);
                  hn = TMReadFile(SHandle,state_buf,hn,data,420);
                  p_printf("read %d",hn); 
                  p_getch();
                  p_printf("Close %d",TMCloseFile(SHandle,state_buf,hn));
                  p_printf("Delete File %d", TMDeleteFile(SHandle, state_buf, flname));
                  hn = TMCreateFile(SHandle,state_buf,&m,flname);
                  p_printf("Create file %d  max %d",hn,m);  
                  p_printf("Close %d",TMCloseFile(SHandle,state_buf,hn));
                  p_printf("Delete File %d", TMDeleteFile(SHandle, state_buf, flname));
                  p_getch();
                  
               }//end if rom = 0x0c
            }// end if TMNext = 1
            else
            {
            
               p_printf("Total Parts Found %d", count);
               p_printf("end of search");
               p_printf("Search One Wire Net (y/n)");
               key = p_getch();
               count = 0;
            }
         }//else setup complete

         // close the opened session 
         TMEndSession(SHandle);
      }// if Session > 0
   } 
   while (key != 'n');

   p_printf("PSION Demo end");
   return(1);

}


